# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `rime-api-key` header.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
import warnings
from datetime import datetime
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr
from typing import Optional
from typing_extensions import Annotated
from ri.apiclient.models.generativetesting_get_generative_model_test_results_response import GenerativetestingGetGenerativeModelTestResultsResponse
from ri.apiclient.models.generativetesting_start_generative_model_test_request import GenerativetestingStartGenerativeModelTestRequest
from ri.apiclient.models.generativetesting_start_generative_model_test_response import GenerativetestingStartGenerativeModelTestResponse

from ri.apiclient.models import *
from ri.apiclient.api_client import ApiClient, RequestSerialized
from ri.apiclient.api_response import ApiResponse
from ri.apiclient.rest import RESTResponseType


class GenerativeModelTestingApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_call
    def quick_scan(
        self,
        url: str,
        endpoint_payload_template: str,
        response_json_path: str,
        http_headers: Optional[Dict[str, str]] = None,
        http_auth_integration_id: Optional[RimeUUID] = None,
        name: Optional[str] = None,
        mutual_tls_integration_id: Optional[RimeUUID] = None,
        system_prompt: Optional[str] = None,
    ) -> GenerativetestingStartGenerativeModelTestResponse:
        """QuickScan

        Starts a generative model test on the specified GAI model with a simple prompt bank.  This is only meant to be used to test your setup and connections, results should not be seen as complete nor actionable. The status of the job can be tracked through the JobReader service. The results can of the test can be retrieved using the GetGenerativeModelTestResults API.

        :param url: Parameters for connecting to the user's generative model. (required)
        :type url: str
        :param endpoint_payload_template: A string template that will be used to create the json payload sent to the LLM endpoint. This template must contain one and only one variable -- prompt_string. This will be replaced at runtime with the prompt used to send to the model.  The template uses \" and \" as the opening and closing delimiters around the prompt_string variable name.  Example: '{ \"prompt\": \"{{prompt_string}}\" }' Example: '{ \"message\": { \"llm_prompt\": \"{{prompt_string}}\" } }' (required)
        :type endpoint_payload_template: str
        :param response_json_path: A json path specifying where in the HTTP response json payload we can find the LLM's response string. Note that the path must point to a string value in the json payload. Whitespace and other special characters can be encoded as unicode (\\u0020). Periods in json fields can be escaped with a backslash.  Example (top level field): - Endpoint response json: {\"response\": \"I am an AI Chatbot, how can I assist you?\"} - response_json_path: \"response\"  Example (nested json field): - Endpoint response json: {\"response\": {\"llmResponse\": \"I am an AI Chatbot, how can I assist you?\"}} - response_json_path: \"response.llmResponse\"  Example (extract string from array): - Endpoint response: {\"response\": {\"options\": [\"Hi\", \"Hello there\"], \"count\": 2}} - response_json_path: \"response.options.1\"  Example (periods in field names): - Endpoint response: {\"llm.response\": \"hello\"} - response_json_path: \"llm\\\\.response\"  The syntax uses dot notation only, such as \"myfield.myotherfield\" or \"myarray.1\". (required)
        :type response_json_path: str
        :param http_headers:
        :type http_headers: Dict[str, str]
        :param http_auth_integration_id:
        :type http_auth_integration_id: RimeUUID
        :param name: The name to identify the generative model testing job.
        :type name: str
        :param mutual_tls_integration_id:
        :type mutual_tls_integration_id: RimeUUID
        :param system_prompt: The system prompt that is currently active on the provided endpoint.
        :type system_prompt: str
        :return: Returns the result object.
        """ # noqa: E501

        body = GenerativetestingStartGenerativeModelTestRequest(
          url=url,
          http_headers=http_headers,
          endpoint_payload_template=endpoint_payload_template,
          response_json_path=response_json_path,
          http_auth_integration_id=http_auth_integration_id,
          name=name,
          mutual_tls_integration_id=mutual_tls_integration_id,
          system_prompt=system_prompt,
        )

        _param = self._quick_scan_serialize(
            body=body,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "GenerativetestingStartGenerativeModelTestResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    def _quick_scan_serialize(
        self,
        body,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        if body is not None:
            _body_params = body
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        _default_content_type = (
            self.api_client.select_header_content_type(
                [
                    'application/json'
                ]
            )
        )
        if _default_content_type is not None:
            _header_params['Content-Type'] = _default_content_type

        _auth_settings: List[str] = [
            'rime-api-key'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v1-beta/generative/testing/quick',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
        )

    @validate_call
    def results(
        self,
        job_id_uuid: str,
        page_token: Optional[str] = None,
        page_size: Optional[str] = None,
    ) -> GenerativetestingGetGenerativeModelTestResultsResponse:
        """GetGenerativeModelTestResults

        Retrieve the results of a generative model testing for a successful job. This is a paginated API.

        :param job_id_uuid: Unique object ID. (required)
        :type job_id_uuid: str
        :param page_token: A token representing one page from the list returned by a GetGenerativeModelTestResults API. The GetGenerativeModelTestResults API returns a page_token when there is more than one page of results.
        :type page_token: str
        :param page_size: The maximum number of objects to return in a single page.  Maximum page size is 1000.
        :type page_size: str
        :return: Returns the result object.
        """ # noqa: E501


        _param = self._results_serialize(
            job_id_uuid=job_id_uuid,
            page_token=page_token,
            page_size=page_size,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "GenerativetestingGetGenerativeModelTestResultsResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    def _results_serialize(
        self,
        job_id_uuid,
        page_token,
        page_size,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        if job_id_uuid is not None:
            _path_params['jobId.uuid'] = job_id_uuid
        if page_token is not None:
            
            _query_params.append(('pageToken', page_token))
            
        if page_size is not None:
            
            _query_params.append(('pageSize', page_size))
            
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )


        _auth_settings: List[str] = [
            'rime-api-key'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/v1-beta/generative/testing/{jobId.uuid}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
        )

    @validate_call
    def start_generative_test(
        self,
        url: str,
        endpoint_payload_template: str,
        response_json_path: str,
        http_headers: Optional[Dict[str, str]] = None,
        http_auth_integration_id: Optional[RimeUUID] = None,
        name: Optional[str] = None,
        mutual_tls_integration_id: Optional[RimeUUID] = None,
        system_prompt: Optional[str] = None,
    ) -> GenerativetestingStartGenerativeModelTestResponse:
        """StartGenerativeModelTest

        Starts a generative model test on the specified GAI model with default prompt bank. The status of the job can be tracked through the JobReader service. The results can of the test can be retrieved using the GetGenerativeModelTestResults API.

        :param url: Parameters for connecting to the user's generative model. (required)
        :type url: str
        :param endpoint_payload_template: A string template that will be used to create the json payload sent to the LLM endpoint. This template must contain one and only one variable -- prompt_string. This will be replaced at runtime with the prompt used to send to the model.  The template uses \" and \" as the opening and closing delimiters around the prompt_string variable name.  Example: '{ \"prompt\": \"{{prompt_string}}\" }' Example: '{ \"message\": { \"llm_prompt\": \"{{prompt_string}}\" } }' (required)
        :type endpoint_payload_template: str
        :param response_json_path: A json path specifying where in the HTTP response json payload we can find the LLM's response string. Note that the path must point to a string value in the json payload. Whitespace and other special characters can be encoded as unicode (\\u0020). Periods in json fields can be escaped with a backslash.  Example (top level field): - Endpoint response json: {\"response\": \"I am an AI Chatbot, how can I assist you?\"} - response_json_path: \"response\"  Example (nested json field): - Endpoint response json: {\"response\": {\"llmResponse\": \"I am an AI Chatbot, how can I assist you?\"}} - response_json_path: \"response.llmResponse\"  Example (extract string from array): - Endpoint response: {\"response\": {\"options\": [\"Hi\", \"Hello there\"], \"count\": 2}} - response_json_path: \"response.options.1\"  Example (periods in field names): - Endpoint response: {\"llm.response\": \"hello\"} - response_json_path: \"llm\\\\.response\"  The syntax uses dot notation only, such as \"myfield.myotherfield\" or \"myarray.1\". (required)
        :type response_json_path: str
        :param http_headers:
        :type http_headers: Dict[str, str]
        :param http_auth_integration_id:
        :type http_auth_integration_id: RimeUUID
        :param name: The name to identify the generative model testing job.
        :type name: str
        :param mutual_tls_integration_id:
        :type mutual_tls_integration_id: RimeUUID
        :param system_prompt: The system prompt that is currently active on the provided endpoint.
        :type system_prompt: str
        :return: Returns the result object.
        """ # noqa: E501

        body = GenerativetestingStartGenerativeModelTestRequest(
          url=url,
          http_headers=http_headers,
          endpoint_payload_template=endpoint_payload_template,
          response_json_path=response_json_path,
          http_auth_integration_id=http_auth_integration_id,
          name=name,
          mutual_tls_integration_id=mutual_tls_integration_id,
          system_prompt=system_prompt,
        )

        _param = self._start_generative_test_serialize(
            body=body,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "GenerativetestingStartGenerativeModelTestResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    def _start_generative_test_serialize(
        self,
        body,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        if body is not None:
            _body_params = body
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        _default_content_type = (
            self.api_client.select_header_content_type(
                [
                    'application/json'
                ]
            )
        )
        if _default_content_type is not None:
            _header_params['Content-Type'] = _default_content_type

        _auth_settings: List[str] = [
            'rime-api-key'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v1-beta/generative/testing',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
        )
